<!DOCTYPE html>
<html lang="es">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Pacientes</title>
    <!--CDN Bootstrap-->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.0/css/bootstrap.min.css"
        integrity="sha384-9gVQ4dYFwwWSjIDZnLEWnxCjeSWFphJiwGPXr1jddIhOegiu1FwO5qRGvFXOdJZ4" crossorigin="anonymous">
    <!--Integrando Vue-->
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
    <script src="metodos.js"></script>
</head>

<body>
    <div id="appPacientes" class="container">
        <!-- Formulario para añadir pacientes -->
        <section class="form">
            <form action="" class="text-center">
                <input v-model="nombre" @keyup.enter="crearPaciente" type="text" class="form-control"
                    placeholder="Nombre">
                <input v-model="descripcion" @keyup.enter="crearPaciente" type="text" name="descripcion"
                    placeholder="Descripcion" class="form-control">
                <input v-model="precio" @keyup.enter="crearPaciente" type="number" class="form-control"
                    placeholder="Precio">
                <!-- Botón para añadir -->
                <input @click="crearPaciente" type="button" value="Botón Añadir" class="btn btn-success">
            </form>
        </section>
        <!-- Tabla donde se muestran los datos -->
        <section class="data">
            <caption>Lista de producos</caption>
            <table class="table">
                <thead>
                    <tr>
                        <th scope="col">Nombre</th>
                        <th scope="col">Descripción</th>
                        <th scope="col">Precio</th>
                        <th></th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(paciente, index) in pacientes">
                        <td>
                            <span v-if="formActualizar && idActualizar == index">
                                <!-- Formulario para actualizar -->
                                <input v-model="nombreActualizar" type="text" class="form-control">
                            </span>
                            <span v-else>
                                <!-- Dato nombre -->
                                {{ paciente.nombre }}
                            </span>
                        </td>
                        <td>
                            <span v-if="formActualizar && idActualizar == index">
                                <!-- Formulario para actualizar -->
                                <input v-model="descripcionActualizar" type="text" class="form-control">
                            </span>
                            <span v-else>
                                <!-- Dato nombre -->
                                {{ paciente.descripcion }}
                            </span>
                        </td>
                        <td>
                            <span v-if="formActualizar && idActualizar == index">
                                <!-- Formulario para actualizar -->
                                <input v-model="precioActualizar" type="text" class="form-control">
                            </span>
                            <span v-else>
                                <!-- Dato edad -->
                                {{  paciente.precio}}
                            </span>
                        </td>
                        <td>
                            <!-- Botón para guardar la información actualizada -->
                            <span v-if="formActualizar && idActualizar == index">
                                <button @click="guardarActualizacion(index)" class="btn btn-success">Guardar</button>
                            </span>
                            <span v-else>
                                <!-- Botón para mostrar el formulario de actualizar -->
                                <button @click="verFormActualizar(index)" class="btn btn-warning">Actualizar</button>
                                <!-- Botón para borrar -->
                                <button @click="borrarPaciente(index)" class="btn btn-danger">Borrar</button>
                            </span>
                        </td>
                    </tr>
                </tbody>
            </table>
        </section>
    </div>

    <script>
        document.addEventListener('DOMContentLoaded', function () {
            new Vue({
                el: '#appPacientes',
                data: {
                    // Input nombre
                    nombre: '',
                    // Input descripción
                    descripcion: '',
                    // Input precio
                    precio: '',
                    // Ver o no ver el formulario de actualizar
                    formActualizar: false,
                    // La posición de tu lista donde te gustaría actualizar 
                    idActualizar: -1,
                    // Input nombre dentro del formulario de actualizar
                    nombreActualizar: '',
                    // Input descripcion dentro del formulario de actualizar
                    descripcionActualizar: '',
                    // Input precio dentro del formulario de actualizar
                    precioActualizar: '',
                    // Lista de pacientes
                    pacientes: []
                },
                methods: {
                    crearPaciente: function () {
                        // Anyadimos a nuestra lista
                        this.pacientes.push({
                            id: + new Date(),
                            nombre: this.nombre,
                            descripcion: this.descripcion,
                            precio: this.precio
                        });
                        // Vaciamos el formulario de añadir
                        this.nombre = '';
                        this.descripcion = '';
                        this.precio = '';
                    },
                    verFormActualizar: function (paciente_id) {
                        // Antes de mostrar el formulario de actualizar, rellenamos sus campos
                        this.idActualizar = paciente_id;
                        this.nombreActualizar = this.pacientes[paciente_id].nombre;
                        this.descripcionActualizar = this.pacientes[paciente_id].descripcion;
                        this.precioActualizar = this.pacientes[paciente_id].precio;
                        // Mostramos el formulario
                        this.formActualizar = true;
                    },
                    borrarPaciente: function (paciente_id) {
                        // Borramos de la lista
                        this.pacientes.splice(paciente_id, 1);
                    },
                    guardarActualizacion: function (paciente_id) {
                        // Ocultamos nuestro formulario de actualizar
                        this.formActualizar = false;
                        // Actualizamos los datos
                        this.pacientes[paciente_id].nombre = this.nombreActualizar;
                        this.pacientes[paciente_id].descripcion = this.descripcionActualizar;
                        this.pacientes[paciente_id].precio = this.precioActualizar;
                    }
                }
            });
        });
    </script>

</body>

</html>